# -*- coding: utf-8 -*-
'''
eatdrink.py

Provide functions for eat/drink items
'''

import hooks, mud, char, mudsys

################################################################################
# eat/drink hooks
################################################################################

def eat_hook(info):
    '''Lower player hunger'''
    ch, obj = hooks.parse_info(info)
    data = obj.get_type_data("consumable")
    cur_val = ch.aux('stats').values[6]
    if data.subtype == "jarzyna":
        cur_val -= 5
    elif data.subtype == "pieczywo":
        cur_val -= 10
    elif data.subtype == "mięso":
        cur_val -= 20
    if cur_val < 0:
        cur_val = 0
    ch.aux('stats').values[6] = cur_val

def drink_hook(info):
    '''Lower player thirst'''
    ch, obj = hooks.parse_info(info)
    data = obj.get_type_data("consumable")
    cur_val = ch.aux('stats').values[7]
    if data.subtype == "wodę":
        cur_val -= 10
    elif data.subtype == "piwo":
        cur_val -= 5
    elif data.subtype == "wino":
        cur_val -= 2
    if cur_val < 0:
        cur_val = 0
    ch.aux('stats').values[7] = cur_val
        

################################################################################
# loading and unloading the module
################################################################################
hooks.add("eat", eat_hook)
hooks.add("drink", drink_hook)

def __unload__():
    '''things that need to be detached when the module is un/reloaded'''
    hooks.remove("eat", eat_hook)
    hooks.remove("drink", drink_hook)
