# -*- coding: utf-8 -*-
###########################################################################
#
# Copyright (C) 2010  Bartek thindil Jasicki
#
# This file is part of Anaria MUD.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################
'''
fight.py

Provide functions for fight PvE and PvP
'''

import mudsys, mud, char, mudsock, utils, random, gainlevel, event, hooks, obj
import damage as damfuncs

################################################################################
# functions
################################################################################

def attack_event(owner, data, attackType):
    '''Function made attack and count damage.'''
    #did player have enough stamina for fight?
    attacker = data[0]
    defender = data[1]
    if not attacker[0].hasvar('enemy') or not defender[0].hasvar('enemy'):
        return
    both = []
    if attacker[0].is_pc:
        if attacker[0].aux('stats').values[5] == attacker[0].aux('stats').secondvalues[5]:
            attacker[0].send("Nie masz sił aby atakować!")
            if attackType == 'normal':
                both.append(defender)
                both.append(attacker)
                event.start_event(owner, 2, attack_event, both, 'normal')
            return
        attacker[0].aux('stats').values[5] += 1
    if defender[0].is_pc:
        if defender[0].aux('stats').values[5] == defender[0].aux('stats').secondvalues[5]:
            defender[0].send("Nie masz sił aby się bronić!")
            defender[5] = 0
        else:
            defender[0].aux('stats').values[5] += 1
    #prepare weapon
    attacker[14] -= 1
    if attacker[14] > 0:
        if attacker[0].is_pc:
            attacker[0].send("Przygotowujesz broń do ponownego ataku.")
        if defender[0].is_pc:
            defender[0].send(attacker[0].name + " przygotowuje broń do ponownego ataku.")
        if attackType == 'normal':
            both.append(defender)
            both.append(attacker)
            event.start_event(owner, 2, attack_event, both, 'normal')
        return
    #did attacker hit defender?
    attack = attacker[4] + random.randint(0, 99)
    attacker[14] = attacker[3]
    defense = defender[5] + random.randint(0, 99)
    if defense > attack:
        if defender[0].is_pc:
            if defender[5] < attack:
                if defender[6] == 'Uniki':
                    message = 'Uniknąłeś ataku '
                else:
                    message = 'Zablokowałeś tarczą atak '
                defender[0].send(message + attacker[0].name + "$g.")
                defender[12] = True
            else:
                defender[0].send(attacker[0].name +  " chybia.")
        if attacker[0].is_pc:
            if defender[5] < attack:
                if defender[6] == 'Uniki':
                    message = ' uniknął twojego ataku.'
                else:
                    message = ' zablokował tarczą twój atak.'
                attacker[0].send(defender[0].name + message)
            else:
                attacker[0].send("Chybiasz.")
        if attackType == "normal":
            both.append(defender)
            both.append(attacker)
            event.start_event(owner, 2, attack_event, both, 'normal')
    else:
        damage, hitpart, hitArmor = damfuncs.count_damage(defender[8], defender[7], attacker[1], attacker[2])
        if damage > 0:
            defender[0].aux('stats').values[4] -= damage
            if defender[0].aux('stats').values[4] < 0:
                defender[0].aux('stats').values[4] = 0
        if hitArmor:
            defender[15][hitpart] = True
        if attacker[0].is_pc:
            attacker[0].send('Trafiasz %s$g w %s' % (defender[0].name, hitpart))
            attacker[11] = True
        if defender[0].is_pc:
            defender[0].send('%s trafia ciebie w %s' % (attacker[0].name, hitpart))
        #end of fight?
        if defender[0].aux('stats').values[4] == 0:
            if attacker[0].is_pc:
                attacker[0].send(defender[0].name + " pada martwy na ziemię!")
                attacker[0].aux('alignment').value -= defender[0].aux('alignment').value
                hooks.run("alignment", hooks.build_info("ch", (attacker[0], )))
                expgain = max(defender[0].aux('stats').values)
                if attacker[11]:
                    attacker[0].aux('stats').secondvalues[0] += expgain
                    gainlevel.check_exp(attacker[0], "str", "stat")
                    if attacker[9] > -1:
                        attacker[0].aux('skills').exp[attacker[9]] += expgain
                    else:
                        attacker[0].aux('skills').names.append(attacker[13])
                        attacker[0].aux('skills').levels.append(0)
                        attacker[0].aux('skills').exp.append(expgain)
                    gainlevel.check_exp(attacker[0], attacker[13], "skill")
                    #check if attacker weapon was damaged
                    if attacker[13] != 'Walka wręcz':
                        hooks.run("durability", hooks.build_info("ch obj", (attacker[0], attacker[0].get_equip('dzierżone'))))
                if attacker[12]:
                    attacker[0].aux('stats').secondvalues[1] += expgain
                    gainlevel.check_exp(attacker[0], "dex", "stat")
                    if attacker[10] > -1:
                        attacker[0].aux('skills').exp[attacker[10]] += expgain
                    else:
                        attacker[0].aux('skills').names.append(attacker[6])
                        attacker[0].aux('skills').levels.append(0)
                        attacker[0].aux('skills').exp.append(expgain)
                    gainlevel.check_exp(attacker[0], attacker[6], "skill")
                #check if attacker armor was damaged
                damfuncs.check_armor(attacker[0], attacker[15])
            if defender[0].is_pc:
                #check if defender weapon was damaged
                if defender[13] != 'Walka wręcz' and defender[11]:
                    hooks.run("durability", hooks.build_info("ch obj", (defender[0], defender[0].get_equip('dzierżone'))))
                #check if defender armor was damaged
                damfuncs.check_armor(defender[0], defender[15])
            damfuncs.create_corpse(defender[0], attacker[0].name, 'char')
            attacker[0].delvar('enemy')
            defender[0].delvar('enemy')
        else:
            if attackType == 'normal':
                both.append(defender)
                both.append(attacker)
                event.start_event(owner, 2, attack_event, both, 'normal')

def get_info(ch):
    '''Function return battle informations about selected character.'''
    #set all fight things for player
    chDamage = ch.aux('stats').values[0]
    if ch.race == 'kotołak':
        chDamageType = 'cut'
    else:
        chDamageType = 'crush'
    chPreparation  = 1
    chHitChance = ch.aux('stats').values[0]
    chEvadeChance = ch.aux('stats').values[1]
    #get player weapon info
    chWeapon = ch.get_equip('dzierżone')
    hasAttSkill = -1
    if chWeapon == None or not chWeapon.istype('weapon'):
        chAttSkillName = "Walka wręcz"
    else:
        chAttSkillName = chWeapon.get_type_data("weapon").skill
        chDamage += (chDamage * float(chWeapon.get_type_data("weapon").damage / 100))
        chDamageType = chWeapon.get_type_data("weapon").subtype
        chPreparation = chWeapon.get_type_data("weapon").prepare
    if chAttSkillName in ch.aux('skills').names:
        hasAttSkill = ch.aux('skills').names.index(chAttSkillName)
        chHitChance += ch.aux('skills').levels[hasAttSkill]
    #get player shield info
    chShield = ch.get_equip('trzymane')
    hasDefSkill = -1
    if chShield == None or not chShield.istype('armor'):
        chDefSkillName = 'Uniki'
    else:
        chDefSkillName = 'Tarcza'
        chEvadeChance += chShield.get_type_data('armor').resistance
    if chDefSkillName in ch.aux('skills').names:
        hasDefSkill = ch.aux('skills').names.index(chDefSkillName)
        chEvadeChance += ch.aux('skills').levels[hasDefSkill]
    #get player armor info
    chArmor, chArmorHit, chBody = damfuncs.get_armor(ch)
    return [ch, chDamage, chDamageType, chPreparation, chHitChance, chEvadeChance, chDefSkillName, chArmor, chBody, hasAttSkill, hasDefSkill, False, False, chAttSkillName, 1, chArmorHit]
        
def do_fight(ch, vict):
    '''Function start fight with mobs.'''
    #set all fight things for attacker
    chInfo = get_info(ch)
    #set all fight things for defender
    victInfo = get_info(vict)
    #if attacker is hidden and defender don't spot him, one free attack
    if not vict.cansee(ch):
        if ch.is_pc:
            ch.send('Atak z zaskoczenia!')
            hasSkill = ch.aux('skills').names.index('Ukrywanie się')
            ch.aux('skills').exp[hasSkill] += 1
            gainlevel.check_exp(ch, 'Ukrywanie się', 'skill')
            ch.aux('stats').secondvalues[1] += 1
            gainlevel.check_exp(ch, "dex", "stat")
        both2 = []
        both2.append(chInfo)
        both2.append(victInfo)
        event.start_event(ch, 1, attack_event, both2, 'sudden')
        if vict == None:
            return
    elif ch.hidden > 0:
        if vict.is_pc:
            vict.send(ch.name + " próbował(a) ciebie zaskoczyć!")
            hasSkill = ch.aux('skills').names.index('Spostrzegawczość')
            ch.aux('skills').exp[hasSkill] += 1
            gainlevel.check_exp(ch, 'Spotrzegawczość', 'skill')
            ch.aux('stats').secondvalues[1] += 1
            gainlevel.check_exp(ch, "int", "stat")
    if ch.hidden > 0:
        ch.hidden = 0
    if vict.hidden > 0:
        vict.hidden = 0
    both = []
    #if attacker is better warrior, attack first
    if chInfo[4] > victInfo[4]:
        both.append(chInfo)
        both.append(victInfo)
    else:
        both.append(victInfo)
        both.append(chInfo)
    event.start_event(ch, 1, attack_event, both, 'normal')

################################################################################
# game commands
################################################################################

def cmd_kill(ch, cmd, arg):
    '''Command start fight.'''
    try:
        vict, = mud.parse_args(ch, True, cmd, arg, "ch.room.noself")
    except: return

    if vict.is_pc and not ch.room.hasBit('pkarena') and ch.is_pc:
        ch.send("Nie możesz tutaj walczyć z innym graczem.")
        return

    if vict.hasvar('enemy'):
        if ch.is_pc:
            ch.send(vict.name + " już z kimś walczy.")
        return

    if vict.hasPrefs('immortal'):
        if ch.is_pc:
            ch.send("Nie możesz zaatakować tej postaci.")
        return

    ch.setvar("enemy", vict.name)
    vict.setvar('enemy', ch.name)
    if ch.is_pc:
        ch.send("Atakujesz %s." % (vict.name))
    do_fight(ch, vict)

def cmd_challenge(ch, cmd, arg):
    '''Command challenge other player to duel.'''
    #challenge other player to duel.
    options = ['akceptuj', 'odrzuc', 'cofnij']
    if not arg in options:
        try:
            vict, = mud.parse_args(ch, True, cmd, arg, "ch.room.noself")
        except:
            return

        if vict.is_npc:
            ch.send("Możesz wyzywać na pojedynek tylko innych graczy.")
            return
        if vict.hasvar('enemy'):
            ch.send(vict.name + " już z kimś walczy.")
            return
        if vict.hasvar('challenge'):
            if vict.getvar('challenge') != ch.name:
                ch.send(vict.name + " już został przez kogoś wyzwany.")
                return
            else:
                ch.send("Już raz wyzwałeś " + vict.name  + ". Poczekaj chwilę na odpowiedź.")
                return
        ch.setvar('challenge', vict.name)
        vict.setvar('challenge', ch.name)
        ch.send("Wyzwałeś " + vict.name + "$g na pojedynek!")
        vict.send(ch.name + " wyzwał Ciebie na pojedynek!")
    elif arg == 'cofnij':
        if not ch.hasvar('challenge'):
            ch.send("Nikogo jeszcze nie wyzwałeś na pojedynek.")
            return
        try:
            vict, = mud.parse_args(ch, True, cmd, ch.getvar('challenge'), "ch.world.noself")
        except:
            vict = None
        ch.delvar('challenge')
        ch.send("Wycofałeś swoje wyzwanie.")
        if vict != None:
            vict.delvar('challenge')
            vict.send(ch.name + " wycofał swoje wyzwanie.")
    elif arg == 'odrzuc':
        if not ch.hasvar('challenge'):
            ch.send("Nikt jeszcze nie wyzwał Ciebie na pojedynek.")
            return
        try:
            vict, = mud.parse_args(ch, True, cmd, ch.getvar('challenge'), "ch.world.noself")
        except:
            vict = None
        ch.send("Odrzuciłeś wyzwanie " + ch.getvar('challenge')  + "$g.")
        ch.delvar('challenge')
        if vict != None:
            vict.delvar('challenge')
            vict.send(ch.name + " odrzucił Twoje wyzwanie.")
    elif arg == 'akceptuj':
        try:
            vict, = mud.parse_args(ch, True, cmd, ch.getvar('challenge'), "ch.world.noself")
        except:
            ch.send("Musicie obaj znajdować się w tym samym miejscu aby walczyć ze sobą.")
            return
        ch.setvar('enemy', vict.name)
        ch.delvar('challenge')
        vict.setvar('enemy', ch.name)
        vict.delvar('challenge')
        vict.send(ch.name + " przyjął Twoje wyzwanie. Rozpoczyna się walka!")
        ch.send("Przyjąłeś wyzwanie " + vict.name + "$g. Rozpoczyna się walka!")
        do_fight(ch, vict)

def cmd_appraise(ch, cmd, arg):
    '''Command appraise stats of selected player/mob.'''
    try:
        vict, = mud.parse_args(ch, True, cmd, arg, "ch.room.noself")
    except: return

    better = ['Silniejsz', 'Zwinniejsz', 'Inteligentniejsz', 'Wytrzymalsz', 'Żywotniejsz']
    worse = ['Słabsz', 'Mniej zwinn', 'Mniej inteligentn', 'Mniej wytrzymał', 'Mniej żywotn']
    equal = ['siln', 'zwinn', 'inteligentn', 'wytrzymał', 'żywotn']
    buf = ['Przyglądasz się ' + vict.name + '$d przez chwilę.']

    if vict.sex == "mężczyzna":
        buf.append('Jest on:')
        suffix = 'y'
    else:
        buf.append('Jest ona:')
        suffix = 'a'

    for i in range(0, 5):
        if ch.aux('stats').values[i] > vict.aux('stats').values[i]:
            buf.append(worse[i] + suffix + " od ciebie.")
        elif ch.aux('stats').values[i] == vict.aux('stats').values[i]:
            buf.append('Tak samo ' + equal[i] + suffix + " jak ty.")
        elif ch.aux('stats').values[i] < vict.aux('stats').values[i]:
            buf.append(better[i] + suffix + " niż ty.")
    ch.send('\r\n'.join(buf))
    if vict.is_pc:
        vict.send('Zauważasz że ' + ch.name + ' przygląda się uważnie tobie.')

################################################################################
# fight hooks
################################################################################

def end_fight_hook(info):
    '''When player move from room, end fight - unblock player and mobiles.'''
    ch, rm, ex = hooks.parse_info(info)
    if ch.hasvar('enemy'):
        for char in rm.chars:
            if char.name == ch.getvar('enemy'):
                if char.hasvar('enemy'):
                    if char.getvar('enemy') == ch.name:
                        char.delvar('enemy')
        ch.delvar('enemy')
    
################################################################################
# initialization
################################################################################
mudsys.add_cmd("zabij", None, cmd_kill, "player", True)
mudsys.add_cmd("ocen", None, cmd_appraise, "player", True)
mudsys.add_cmd("wyzwanie", None, cmd_challenge, "player", True)

mudsys.create_bit("room_bits", "pkarena")

hooks.add('exit', end_fight_hook)

def __unload__():
    '''removes the hooks for fight'''
    hooks.remove("exit", end_fight_hook)
