# -*- coding: utf-8 -*-
###########################################################################
#
# Copyright (C) 2010  Bartek thindil Jasicki
#
# This file is part of Anaria.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################
'''
score.py

Player informations - stats, skills, etc
'''

import mudsys, char, mud, math

################################################################################
# game commands
################################################################################
def cmd_score(ch, cmd, arg):
    '''Show player stats.'''
    ch.send("Imię: " + ch.name)
    #count player age
    hours = int((ch.age / 3600)) % 24
    days = int((ch.age / 3600) / 24)
    buf = []
    buf.append("Wiek: %d dni %d godzin(y)" % (days, hours))
    buf.append("Płeć: " + ch.sex)
    buf.append("Rasa: " + ch.race)
    buf.append("Charakter: " + ch.aux('alignment').desc)
    buf.append("Wyznanie: " + ch.aux('faith').deity)
    if len(ch.aux('faith').desc) > 0:
        buf.append("Stosunek bóstwa do ciebie: " + ch.aux('faith').desc)
    i = 0
    for name in ch.aux('stats').names:
        if i < 4:
            stat_percent = (ch.aux('stats').secondvalues[i] / ((ch.aux('stats').values[i] + 1) * 1000)) * 100
            buf.append("%s: %d (%d%% doś)" % (name, ch.aux('stats').values[i], stat_percent))
        else:
            stat_percent = (ch.aux('stats').values[i] / ch.aux('stats').secondvalues[i]) * 100
            buf.append("%s: %d%%" % (name, stat_percent))
        i += 1
    ch.send('\r\n'.join(buf))

def cmd_skills(ch, cmd, arg):
    '''Show player skills.'''
    if len(ch.aux('skills').names) == 0:
        ch.send("Brak umiejętności")
    else:
        i = 0
        for name in ch.aux('skills').names:
            skill_percent = (ch.aux('skills').exp[i] / ((ch.aux('skills').levels[i] + 1) * 100)) * 100
            ch.send("%s: %d (%d%% doś)" % (name, ch.aux('skills').levels[i], skill_percent))
            i += 1

################################################################################
# initialization
################################################################################

#add commands
mudsys.add_cmd("karta", None, cmd_score, "player", False)
mudsys.add_cmd("umiejetnosci", None, cmd_skills, "player", False)
