//bodies.c - list of bodies for npc and players races

#include "../mud.h"
#include "../body.h"
#include "races2.h"

//Standard human body
BODY_DATA *getHumanBody()
{
  BODY_DATA *humanbody = newBody();
  bodyAddPosition(humanbody, "dzierżone",               BODYPOS_WIELD,         0);
  bodyAddPosition(humanbody, "trzymane",                BODYPOS_HELD,          0);
  bodyAddPosition(humanbody, "prawa stopa",             BODYPOS_RIGHT_FOOT,    2);
  bodyAddPosition(humanbody, "lewa stopa",              BODYPOS_LEFT_FOOT,     2);
  bodyAddPosition(humanbody, "prawa noga",              BODYPOS_LEG,           9);
  bodyAddPosition(humanbody, "lewa noga",               BODYPOS_LEG,           9);
  bodyAddPosition(humanbody, "pas",                     BODYPOS_WAIST,         1);
  bodyAddPosition(humanbody, "prawy palec",             BODYPOS_FINGER,        1);
  bodyAddPosition(humanbody, "lewy palec",              BODYPOS_FINGER,        1);
  bodyAddPosition(humanbody, "prawa dłoń",              BODYPOS_RIGHT_HAND,    2);
  bodyAddPosition(humanbody, "lewa dłoń",               BODYPOS_LEFT_HAND,     2);
  bodyAddPosition(humanbody, "prawy nadgarstek",        BODYPOS_WRIST,         1);
  bodyAddPosition(humanbody, "lewy nadgarstek",         BODYPOS_WRIST,         1);
  bodyAddPosition(humanbody, "prawa ręka",              BODYPOS_ARM,           7);
  bodyAddPosition(humanbody, "lewa ręka",               BODYPOS_ARM,           7);
  bodyAddPosition(humanbody, "przy ciele",              BODYPOS_ABOUT,         0);
  bodyAddPosition(humanbody, "tułów",                   BODYPOS_TORSO,        50);
  bodyAddPosition(humanbody, "szyja",                   BODYPOS_NECK,          1);
  bodyAddPosition(humanbody, "prawe ucho",              BODYPOS_EAR,           0);
  bodyAddPosition(humanbody, "lewe ucho",               BODYPOS_EAR,           0);
  bodyAddPosition(humanbody, "twarz",                   BODYPOS_FACE,          2);
  bodyAddPosition(humanbody, "głowa",                   BODYPOS_HEAD,          2);
  bodyAddPosition(humanbody, "plecy",                   BODYPOS_BACK,          0);
  return humanbody;
}
 
//Standard quadruped body
BODY_DATA *getQuadrupedBody()
{
  BODY_DATA *quadbody = newBody();
  bodyAddPosition(quadbody, "tylnia prawa łapa",        BODYPOS_RIGHT_FOOT,    2);
  bodyAddPosition(quadbody, "tylnia lewa łapa",         BODYPOS_LEFT_FOOT,     2);
  bodyAddPosition(quadbody, "tylnia prawa noga",        BODYPOS_LEG,           8);
  bodyAddPosition(quadbody, "tylnia lewa noga",         BODYPOS_LEG,           8);
  bodyAddPosition(quadbody, "przednia prawa łapa",      BODYPOS_RIGHT_HAND,    2);
  bodyAddPosition(quadbody, "przednia lewa łapa",       BODYPOS_LEFT_HAND,     2);
  bodyAddPosition(quadbody, "przednia prawa noga",      BODYPOS_ARM,           8);
  bodyAddPosition(quadbody, "przednia lewa noga",       BODYPOS_ARM,           8);
  bodyAddPosition(quadbody, "tułów",                    BODYPOS_TORSO,        50);
  bodyAddPosition(quadbody, "szyja",                    BODYPOS_NECK,          2);
  bodyAddPosition(quadbody, "prawe ucho",               BODYPOS_EAR,           1);
  bodyAddPosition(quadbody, "lewe ucho",                BODYPOS_EAR,           1);
  bodyAddPosition(quadbody, "pysk",                     BODYPOS_FACE,          2);
  bodyAddPosition(quadbody, "głowa",                    BODYPOS_HEAD,          2);
  bodyAddPosition(quadbody, "ogon",                     BODYPOS_HEAD,          2);
  return quadbody;
}

//Standard insect body
BODY_DATA *getInsectBody()
{
  BODY_DATA *insectbody = newBody();
  bodyAddPosition(insectbody, "środkowa prawa noga",    BODYPOS_LEG,           8);
  bodyAddPosition(insectbody, "środkowa lewa noga",     BODYPOS_LEG,           8);
  bodyAddPosition(insectbody, "tylnia prawa noga",      BODYPOS_LEG,           8);
  bodyAddPosition(insectbody, "tylnia lewa noga",       BODYPOS_LEG,           8);
  bodyAddPosition(insectbody, "przednia prawa noga",    BODYPOS_LEG,           8);
  bodyAddPosition(insectbody, "przednia lewa noga",     BODYPOS_LEG,           8);
  bodyAddPosition(insectbody, "tułów",                  BODYPOS_TORSO,        50);
  bodyAddPosition(insectbody, "głowa",                  BODYPOS_HEAD,          2);
  return insectbody;
}

//Standard crawler body
BODY_DATA *getCrawlerBody()
{
  BODY_DATA *crawlerbody = newBody();
  bodyAddPosition(crawlerbody, "tułów",                 BODYPOS_TORSO,        50);
  bodyAddPosition(crawlerbody, "pysk",                  BODYPOS_FACE,         15);
  bodyAddPosition(crawlerbody, "głowa",                 BODYPOS_HEAD,         15);
  bodyAddPosition(crawlerbody, "ogon",                  BODYPOS_HEAD,         20);
  return crawlerbody;
}

//Human body with wings
BODY_DATA *getFHumanBody()
{
  BODY_DATA *fhumanbody = newBody();
  bodyAddPosition(fhumanbody, "dzierżone",               BODYPOS_WIELD,         0);
  bodyAddPosition(fhumanbody, "trzymane",                BODYPOS_HELD,          0);
  bodyAddPosition(fhumanbody, "prawa stopa",             BODYPOS_RIGHT_FOOT,    2);
  bodyAddPosition(fhumanbody, "lewa stopa",              BODYPOS_LEFT_FOOT,     2);
  bodyAddPosition(fhumanbody, "prawa noga",              BODYPOS_LEG,           8);
  bodyAddPosition(fhumanbody, "lewa noga",               BODYPOS_LEG,           8);
  bodyAddPosition(fhumanbody, "pas",                     BODYPOS_WAIST,         1);
  bodyAddPosition(fhumanbody, "prawy palec",             BODYPOS_FINGER,        1);
  bodyAddPosition(fhumanbody, "lewy palec",              BODYPOS_FINGER,        1);
  bodyAddPosition(fhumanbody, "prawa dłoń",              BODYPOS_RIGHT_HAND,    2);
  bodyAddPosition(fhumanbody, "lewa dłoń",               BODYPOS_LEFT_HAND,     2);
  bodyAddPosition(fhumanbody, "prawy nadgarstek",        BODYPOS_WRIST,         1);
  bodyAddPosition(fhumanbody, "lewy nadgarstek",         BODYPOS_WRIST,         1);
  bodyAddPosition(fhumanbody, "prawa ręka",              BODYPOS_ARM,           6);
  bodyAddPosition(fhumanbody, "lewa ręka",               BODYPOS_ARM,           6);
  bodyAddPosition(fhumanbody, "przy ciele",              BODYPOS_ABOUT,         0);
  bodyAddPosition(fhumanbody, "tułów",                   BODYPOS_TORSO,        44);
  bodyAddPosition(fhumanbody, "szyja",                   BODYPOS_NECK,          1);
  bodyAddPosition(fhumanbody, "prawe ucho",              BODYPOS_EAR,           0);
  bodyAddPosition(fhumanbody, "lewe ucho",               BODYPOS_EAR,           0);
  bodyAddPosition(fhumanbody, "twarz",                   BODYPOS_FACE,          2);
  bodyAddPosition(fhumanbody, "głowa",                   BODYPOS_HEAD,          2);
  bodyAddPosition(fhumanbody, "prawe skrzydło",          BODYPOS_WING,          5);
  bodyAddPosition(fhumanbody, "lewe skrzydło",           BODYPOS_WING,          5);
  return fhumanbody;
}

//Human body with tail
BODY_DATA *getTHumanBody()
{
  BODY_DATA *thumanbody = newBody();
  bodyAddPosition(thumanbody, "dzierżone",               BODYPOS_WIELD,         0);
  bodyAddPosition(thumanbody, "trzymane",                BODYPOS_HELD,          0);
  bodyAddPosition(thumanbody, "prawa stopa",             BODYPOS_RIGHT_FOOT,    2);
  bodyAddPosition(thumanbody, "lewa stopa",              BODYPOS_LEFT_FOOT,     2);
  bodyAddPosition(thumanbody, "prawa noga",              BODYPOS_LEG,           9);
  bodyAddPosition(thumanbody, "lewa noga",               BODYPOS_LEG,           9);
  bodyAddPosition(thumanbody, "pas",                     BODYPOS_WAIST,         1);
  bodyAddPosition(thumanbody, "prawy palec",             BODYPOS_FINGER,        1);
  bodyAddPosition(thumanbody, "lewy palec",              BODYPOS_FINGER,        1);
  bodyAddPosition(thumanbody, "prawa dłoń",              BODYPOS_RIGHT_HAND,    2);
  bodyAddPosition(thumanbody, "lewa dłoń",               BODYPOS_LEFT_HAND,     2);
  bodyAddPosition(thumanbody, "prawy nadgarstek",        BODYPOS_WRIST,         1);
  bodyAddPosition(thumanbody, "lewy nadgarstek",         BODYPOS_WRIST,         1);
  bodyAddPosition(thumanbody, "prawa ręka",              BODYPOS_ARM,           7);
  bodyAddPosition(thumanbody, "lewa ręka",               BODYPOS_ARM,           7);
  bodyAddPosition(thumanbody, "przy ciele",              BODYPOS_ABOUT,         0);
  bodyAddPosition(thumanbody, "tułów",                   BODYPOS_TORSO,        48);
  bodyAddPosition(thumanbody, "szyja",                   BODYPOS_NECK,          1);
  bodyAddPosition(thumanbody, "prawe ucho",              BODYPOS_EAR,           0);
  bodyAddPosition(thumanbody, "lewe ucho",               BODYPOS_EAR,           0);
  bodyAddPosition(thumanbody, "twarz",                   BODYPOS_FACE,          2);
  bodyAddPosition(thumanbody, "głowa",                   BODYPOS_HEAD,          2);
  bodyAddPosition(thumanbody, "ogon",                    BODYPOS_TAIL,          2);
  bodyAddPosition(thumanbody, "plecy",                   BODYPOS_BACK,          0);
  return thumanbody;
}

BODY_DATA *getBody(int size, const char* type)
{ 
  BODY_DATA* body = newBody();
  if (!strcmp(type, "human"))
    {
      body = bodyCopy(getHumanBody());
    }
  if (!strcmp(type, "quadruped"))
    {
      body = bodyCopy(getQuadrupedBody());
    }
  if (!strcmp(type, "crawler"))
    {
      body = bodyCopy(getCrawlerBody());
    }
  if (!strcmp(type, "humanwings"))
    {
      body = bodyCopy(getFHumanBody());
    }
  if (!strcmp(type, "humantail"))
    {
      body = bodyCopy(getTHumanBody());
    }
  if (!strcmp(type, "insect"))
    {
      body = bodyCopy(getInsectBody());
    }
  bodySetSize(body, size);
  return body;
}
